/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 187 by dpavlin, Tue Mar 16 21:36:45 2010 UTC revision 194 by dpavlin, Mon Mar 22 21:48:27 2010 UTC
# Line 16  Line 16 
16  #  #
17  # based on Tony Risinger post to lxc-users mailing list  # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
# Line 33  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41  }  }
42    
43    
44  lxc_status() {  lxc_status() {
45          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
46                  on_boot="       "                  boot="    "
47                  test -s /var/lib/lxc/$name/on_boot && on_boot="on_boot"                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
48                  echo "$name $status $on_boot $(lxc_rootfs $name)"                  echo "$name $status $boot $(lxc_rootfs $name)"
49          done          done
50  }  }
51    
# Line 73  setup_inittab() { Line 77  setup_inittab() {
77  }  }
78    
79    
80    lxc_log() {
81            echo `date +%Y-%m-%dT%H:%M:%S` $*
82    }
83    
84    
85  lxc_kill() {  lxc_kill() {
86          name=$1          name=$1
87          sig=$2          sig=$2
# Line 82  lxc_kill() { Line 91  lxc_kill() {
91                  lxc-info -n $name                  lxc-info -n $name
92                  exit 1                  exit 1
93          fi          fi
94          echo "$name kill $sig $init_pid"          lxc_log "$name kill $sig $init_pid"
95          /bin/kill $sig $init_pid          /bin/kill $sig $init_pid
96  }  }
97    
98  lxc_stop() {  lxc_stop() {
99            lxc_log "$name stop"
100          lxc_kill $name -SIGPWR          lxc_kill $name -SIGPWR
101          lxc-wait -n $name -s STOPPED          lxc-wait -n $name -s STOPPED
102            lxc_log "$name stoped"
103  #       rm -f /var/lib/lxc/${name}/on_boot  #       rm -f /var/lib/lxc/${name}/on_boot
104  }  }
105    
# Line 97  lxc_start() { Line 108  lxc_start() {
108          name=$1          name=$1
109    
110          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
111                  echo "$name start"                  lxc_log "$name start"
112                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
113                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
114                  lxc-info  -n $name                  lxc-info  -n $name
# Line 105  lxc_start() { Line 116  lxc_start() {
116          fi          fi
117  }  }
118    
 lxc_log() {  
         echo `date +%Y-%m-%dT%H:%M:%S` $*  
 }  
   
119  lxc_watchdog() {  lxc_watchdog() {
120  name=$1  name=$1
121  rootfs=$(lxc_rootfs $1)  rootfs=$(lxc_rootfs $1)
# Line 152  while true; do Line 159  while true; do
159          inotifywait -qqt 300 ${vps_utmp}          inotifywait -qqt 300 ${vps_utmp}
160  done  done
161    
162  lxc_log "$name exited"  lxc_log "$name watchdog exited"
163    
164  }  }
165    
166    
167    usage() {
168            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
169            exit 3
170    }
171    
172  command_on_lxc() {  command_on_lxc() {
173  command=$1  command=$1
174  shift  shift
# Line 168  case "$command" in Line 180  case "$command" in
180  start)  start)
181          lxc_exists $1          lxc_exists $1
182          cleanup_init_scripts $1          cleanup_init_scripts $1
183          setup_inittab $1 ::power      "p0::powerfail:/sbin/init 0"          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
184          setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
185            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
186          lxc_start $1          lxc_start $1
187          # give container 5 seconds to start more than one process          # give container 5 seconds to start more than one process
188          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
# Line 184  reload|force-reload|restart|reboot) Line 197  reload|force-reload|restart|reboot)
197  watchdog)  watchdog)
198          lxc_watchdog $1          lxc_watchdog $1
199          ;;          ;;
200    boot)
201            echo $1 > /var/lib/lxc/$1/on_boot
202            ;;
203    disable)
204            echo -n > /var/lib/lxc/$1/on_boot
205            ;;
206  *)  *)
207          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
208          ;;          ;;
209    
210  esac  esac
# Line 194  esac Line 212  esac
212  }  }
213    
214  command=$1  command=$1
215  shift  test -z "$command" && usage
   
216  test "$command" = "status" && lxc_status && exit  test "$command" = "status" && lxc_status && exit
217    shift
218    
219  if [ -z "$1" ] ; then  if [ -z "$1" ] ; then
220          ls /var/lib/lxc/*/on_boot | while read path ; do          ls /var/lib/lxc/*/on_boot | while read path ; do
221                  name=`echo $path | cut -d/ -f5`                  name=`echo $path | cut -d/ -f5`
222                  command_on_lxc $command $name                  if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
223                            command_on_lxc $command $name
224                    else
225                            echo "# skip $command $name"
226                    fi
227          done          done
228  else  else
229          while [ ! -z "$1" ] ; do          while [ ! -z "$1" ] ; do

Legend:
Removed from v.187  
changed lines
  Added in v.194

  ViewVC Help
Powered by ViewVC 1.1.26